.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
include msvcrt.inc
includelib msvcrt.lib
.data
inputStatement db "Enter Number or command(0: pop, other number: number to be pushed in the stack) : ", 0
numberFormat db "%d", 0 ; format for scan
outputFormat db "pop %d", 10, 0 ; format for pop

space dd 10 dup(1) ; stack
pushErrorStatement db "ERROR THE STACK IS FULL", 10, 0 ; error statement
popErrorStatement db "ERROR THE STACK IS EMPTY", 10, 0 ; error statement

stacklength dd 10, 0 ; stack length
top dd 11, 0 ; point to the end of stack ; pointer to the top
inputnumber dd "%d", 0 ; hold the input number

.code
start:
	mov EBP, offset space + 10 * 4 ; Move end address(large address) of space to EBP
	jmp input ; jmp to input

input:
	invoke crt_printf, addr inputStatement 
	invoke crt_scanf, addr numberFormat, addr inputnumber ; input number
	mov ECX, inputnumber ; load the inputnumber in register ECX
	; compare content of ECX with 0(fill it)
	; if content of ECX is equal to 0, then jump to popnumber(inputnumber 0 represents action "pop")(fill it)
	; jmp to pushnumber(fill it)

pushnumber:
	mov EAX, top ; load the top pointer to EAX 
	cmp EAX, 1 ; see if stack is full(when the stack full, top == 1)
	je pusherror ; if stack is full, jump to pusherror
	; sub the pointer(fill it)
	mov top, EAX ; store the pointer to memory
	mov ECX, inputnumber
	; push the inputnumber in stack in memory(fill it)
	jmp input

popnumber:
	mov EAX, top ; load the top pointer to EAX
	mov EBX, stacklength ; load the stack length to EBX
	add EBX, 1;
	; see if the stack is empty(when the stack empty, top = stacklength + 1)(fill it)
	; if the stack is empty jump to poperror(fill it)
	mov ECX, [EBP - 4 * 10 + 4 * EAX - 4] ; get the top data of in the stack in memory, and load it to ECX
	invoke crt_printf, addr outputFormat, ECX ; print out the top data
	mov EAX, top ; load the top pointer to EAX
	; add the pointer(fill it)
	; store the pointer to memory(fill it)
	jmp input

pusherror:
	invoke crt_printf, addr pushErrorStatement ; print error message
	jmp exitprogram

poperror:
	; print error message(fill it)
	jmp exitprogram

exitprogram:
	invoke ExitProcess, NULL

end start